﻿Imports System
Imports System.IO.Ports

Public Class Form1
    Dim thread, check As System.Threading.Thread
    Dim screen_resolution As Point
    Dim temp_key
    Dim write_left_click As Boolean
    Dim write_right_click As Boolean
    Dim lshift_key, lshift_pressed, lshift_released, rshift_key, rshift_pressed, rshift_released As Boolean
    Dim up_key, up_pressed, up_released As Boolean
    Dim lalt_pressed, ralt_pressed As Boolean
    Dim write_keyboard_string As Boolean
    Dim idle As Integer
    Dim macro_editor, macro_editor_enabled As Boolean

    Dim loop_routines As Boolean
    Dim x As Integer
    Dim y As Integer

    Dim com As String = "COM"
    Dim validport As Boolean

    'Read from comport, connection test querying
    Public Sub readthread()
        Dim message
        Do Until (validport = True)
            Try
                message = SerialPort1.ReadLine.ToString
                If message.Substring(0, message.ToString.Length - 1) = "mbeddevice" Then
                    validport = True
                End If
            Catch ex As Exception
            End Try
        Loop
    End Sub

    'Initiate device and initiate comunication
    Private Sub Form1_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        CheckForIllegalCrossThreadCalls = False
        check = New System.Threading.Thread(AddressOf readthread)
        check.Start()
        SerialPort1.ReadTimeout = 50
        For i = 0 To 256
            Try
                If validport = True Then
                    Exit For
                End If
                SerialPort1.PortName = com + i.ToString
                SerialPort1.Open()
                SerialPort1.WriteLine("DRCmbed")
                System.Threading.Thread.Sleep(50) 'allow time for thread to read reply
            Catch ex As Exception
                Try
                    SerialPort1.Close()
                Catch ex1 As Exception
                End Try
            End Try
        Next
        thread = New System.Threading.Thread(AddressOf mouse_keyboard)
        thread.Start()
    End Sub
    Private Sub Form1_FormClosing(sender As Object, e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Try
            SerialPort1.Close()
            thread.Abort()
            check.Abort()
        Catch ex As Exception
        End Try
    End Sub

    'Map Mouse to 32767 (HID Maximum) and Send mouse location (Moves Mouse to HID Maximum Mapped Resolution on Slave Computer)
    Public Sub mouse_keyboard()
        Try
            Dim last_vector = ""
            idle = 50
            Do
                'Detect Screen Resolution
                screen_resolution = My.Computer.Screen.Bounds.Size 'Just incase they change resolution
                If screen_resolution.X = 1680 And screen_resolution.Y = 1050 Then
                    x = CInt(MousePosition.X * 19.516)
                    y = CInt(MousePosition.Y * 31.236)
                End If
                If screen_resolution.X = 1366 And screen_resolution.Y = 768 Then
                    x = CInt(MousePosition.X * 24.005)
                    y = CInt(MousePosition.Y * 42.721)
                End If
                If screen_resolution.X = 1024 And screen_resolution.Y = 768 Then
                    x = CInt(MousePosition.X * 32.03)
                    y = CInt(MousePosition.Y * 42.721)
                End If
                ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
                'Print Current Mouse Mapped Vectors
                Me.Text = "mbedKM [HID Maximum Vector X:" + x.ToString + " Y:" + y.ToString + "] - Device on: " + SerialPort1.portname
                ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
                'Check if eiter of the check box's are ticked
                If CheckBox1.CheckState = CheckState.Checked Or CheckBox3.CheckState = CheckState.Checked Then
                    'Write mouse location
                    Try
                        If x = 0 Then
                            x = 1
                        End If
                        If y = 0 Then
                            y = 1
                        End If
                        'Prevent pointless sends to the device
                        If last_vector = "Vector," + x.ToString + "," + y.ToString Then
                        Else
                            SerialPort1.WriteLine("Vector," + x.ToString + "," + y.ToString)
                            last_vector = "Vector," + x.ToString + "," + y.ToString
                        End If
                    Catch ex As Exception
                    End Try


                    'Submit a left click
                    If write_left_click = True Then
                        SerialPort1.WriteLine("Click,LClick")
                        write_left_click = False
                    End If

                    'Submit a right click
                    If write_right_click = True Then
                        SerialPort1.WriteLine("Click,RClick")
                        write_right_click = False
                    End If

                    'Submit a left click hold
                    If rshift_pressed = True Then
                        SerialPort1.WriteLine("Click,LPress")
                        rshift_pressed = False
                    End If

                    'Submit a left click release
                    If rshift_released = True Then
                        SerialPort1.WriteLine("Click,LRelease")
                        rshift_released = False
                    End If

                    'Submit a right click hold
                    If up_pressed = True Then
                        SerialPort1.WriteLine("Click,RPress")
                        up_pressed = False
                    End If

                    'Submit a right click release
                    If up_released = True Then
                        SerialPort1.WriteLine("Click,RRelease")
                        up_released = False
                    End If

                    'Submit a scroll up
                    If lalt_pressed = True Then
                        SerialPort1.WriteLine("Scroll,Up")
                        lalt_pressed = False
                    End If
                    'Submit a scroll down
                    If ralt_pressed = True Then
                        SerialPort1.WriteLine("Scroll,Down")
                        ralt_pressed = False
                    End If

                    'Submit a string
                    If write_keyboard_string = True Then
                        'Replace spaces with [SPACE] for mbed to replace as spaces cut the string
                        SerialPort1.WriteLine("Type," + TextBox1.Text.Replace(" ", "[SPACE]"))
                        write_keyboard_string = False
                        TextBox1.Text = ""
                    End If
                End If
                System.Threading.Thread.Sleep(idle) 'Prevent serial command traversing
            Loop
        Catch ex As Exception
            thread.Abort()
        End Try
    End Sub

    'Port Select
    Private Sub ComboBox2_SelectedIndexChanged(sender As System.Object, e As System.EventArgs)
        Try
            SerialPort1.Close()
        Catch ex As Exception
        End Try
        Try
            SerialPort1.Open()
        Catch ex As Exception
            MsgBox("Port already open or in use by another application", MsgBoxStyle.Exclamation, "Cannot Communicate With Port")
        End Try
    End Sub


    'Send Function
    Private Sub Button4_Click(sender As System.Object, e As System.EventArgs) Handles Button4.Click
        Try
            SerialPort1.WriteLine(ListBox1.SelectedItem)
        Catch ex As Exception
        End Try
    End Sub

    'Write String to Device
    Private Sub Button3_Click(sender As System.Object, e As System.EventArgs)
        Try
            SerialPort1.WriteLine("Type," + TextBox1.Text.Replace(" ", "[SPACE]"))
        Catch ex As Exception
        End Try
    End Sub

    'Function Testing with Slave Control
    Private Sub TextBox1_KeyDown(sender As Object, e As System.Windows.Forms.KeyEventArgs) Handles TextBox1.KeyDown
        temp_key = e.KeyCode.ToString
        Label2.Text = "Key: " + temp_key
        If temp_key = "Return" Then
            write_keyboard_string = True
            temp_key = ""
        End If
        If temp_key = "Left" Then
            write_left_click = True
            temp_key = ""
        End If
        If temp_key = "Right" Then
            write_right_click = True
            temp_key = ""
        End If

        If temp_key = "ShiftKey" Then
            If rshift_key = True Then
                rshift_released = True
                rshift_key = False
            Else
                rshift_pressed = True
                rshift_key = True
            End If
            temp_key = ""
        End If
        If temp_key = "Up" Then
            If up_key = True Then
                up_released = True
                up_key = False
            Else
                up_pressed = True
                up_key = True
            End If
            temp_key = ""
        End If

    End Sub

    'Remove Selected Function from Macro List
    Private Sub Button13_Click(sender As System.Object, e As System.EventArgs) Handles Button13.Click
        Try
            ListBox4.Items.RemoveAt(ListBox4.SelectedIndex)
        Catch ex As Exception
        End Try
    End Sub

    'Clear Macro Function List
    Private Sub Button54_Click(sender As System.Object, e As System.EventArgs) Handles Button54.Click
        ListBox4.Items.Clear()
    End Sub

    'Addable Functions to macro editor list
    Private Sub Button2_Click(sender As System.Object, e As System.EventArgs) Handles Button2.Click
        ListBox4.Items.Add("Click,LClick")
    End Sub
    Private Sub Button3_Click_1(sender As System.Object, e As System.EventArgs) Handles Button3.Click
        ListBox4.Items.Add("Click,RClick")
    End Sub
    Private Sub Button5_Click(sender As System.Object, e As System.EventArgs) Handles Button5.Click
        ListBox4.Items.Add("Click,LPress")
    End Sub
    Private Sub Button6_Click(sender As System.Object, e As System.EventArgs) Handles Button6.Click
        ListBox4.Items.Add("Click,RPress")
    End Sub
    Private Sub Button7_Click(sender As System.Object, e As System.EventArgs) Handles Button7.Click
        ListBox4.Items.Add("Click,LDClick")
    End Sub
    Private Sub Button8_Click(sender As System.Object, e As System.EventArgs) Handles Button8.Click
        ListBox4.Items.Add("Click,RDClick")
    End Sub
    Private Sub Button9_Click(sender As System.Object, e As System.EventArgs) Handles Button9.Click
        ListBox4.Items.Add("Scroll," + NumericUpDown1.Value.ToString)
    End Sub
    Private Sub Button10_Click(sender As System.Object, e As System.EventArgs) Handles Button10.Click
        ListBox4.Items.Add("Scroll," + NumericUpDown1.Value.ToString)
    End Sub
    Private Sub Button11_Click(sender As System.Object, e As System.EventArgs) Handles Button11.Click
        ListBox4.Items.Add("Vector," + NumericUpDown3.Value.ToString + "," + NumericUpDown4.Value.ToString)
    End Sub
    Private Sub Button55_Click(sender As System.Object, e As System.EventArgs) Handles Button55.Click
        ListBox4.Items.Add("Keyboard,Tab")
    End Sub
    Private Sub Button56_Click(sender As System.Object, e As System.EventArgs) Handles Button56.Click
        ListBox4.Items.Add("Keyboard,Capslock")
    End Sub
    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
        ListBox4.Items.Add("Keyboard,Return")
    End Sub
    Private Sub Button57_Click(sender As System.Object, e As System.EventArgs) Handles Button57.Click
        ListBox4.Items.Add("Keyboard,Backspace")
    End Sub
    Private Sub Button58_Click(sender As System.Object, e As System.EventArgs) Handles Button58.Click
        ListBox4.Items.Add("Keyboard,FKey" + NumericUpDown2.Value.ToString)
    End Sub
    Private Sub Button62_Click(sender As System.Object, e As System.EventArgs) Handles Button62.Click
        ListBox4.Items.Add("Volume,Up")
    End Sub
    Private Sub Button61_Click(sender As System.Object, e As System.EventArgs) Handles Button61.Click
        ListBox4.Items.Add("Volume,Down")
    End Sub
    Private Sub Button12_Click(sender As System.Object, e As System.EventArgs) Handles Button12.Click
        ListBox4.Items.Add("IdleWait," + NumericUpDown5.Value.ToString)
    End Sub
    Private Sub Button15_Click(sender As System.Object, e As System.EventArgs) Handles Button15.Click
        If TextBox4.Text <> "" Then
            ListBox4.Items.Add("Type," + TextBox4.Text)
        End If
    End Sub

    'Add to Routines
    Private Sub Button16_Click(sender As System.Object, e As System.EventArgs) Handles Button16.Click
        For i = 0 To ListBox4.Items.Count - 1
            Routine1.Items.Add(ListBox4.Items.Item(i))
        Next
    End Sub
    Private Sub Button19_Click(sender As System.Object, e As System.EventArgs) Handles Button19.Click
        For i = 0 To ListBox4.Items.Count - 1
            Routine2.Items.Add(ListBox4.Items.Item(i))
        Next
    End Sub
    Private Sub Button21_Click(sender As System.Object, e As System.EventArgs) Handles Button21.Click
        For i = 0 To ListBox4.Items.Count - 1
            Routine3.Items.Add(ListBox4.Items.Item(i))
        Next
    End Sub
    Private Sub Button23_Click(sender As System.Object, e As System.EventArgs) Handles Button23.Click
        For i = 0 To ListBox4.Items.Count - 1
            Routine4.Items.Add(ListBox4.Items.Item(i))
        Next
    End Sub
    Private Sub Button25_Click(sender As System.Object, e As System.EventArgs) Handles Button25.Click
        For i = 0 To ListBox4.Items.Count - 1
            Routine5.Items.Add(ListBox4.Items.Item(i))
        Next
    End Sub
    Private Sub Button27_Click(sender As System.Object, e As System.EventArgs) Handles Button27.Click
        For i = 0 To ListBox4.Items.Count - 1
            Routine6.Items.Add(ListBox4.Items.Item(i))
        Next
    End Sub
    Private Sub Button17_Click(sender As System.Object, e As System.EventArgs) Handles Button17.Click
        For i = 0 To ListBox4.Items.Count - 1
            Routine7.Items.Add(ListBox4.Items.Item(i))
        Next
    End Sub
    Private Sub Button18_Click(sender As System.Object, e As System.EventArgs) Handles Button18.Click
        For i = 0 To ListBox4.Items.Count - 1
            Routine8.Items.Add(ListBox4.Items.Item(i))
        Next
    End Sub
    Private Sub Button20_Click(sender As System.Object, e As System.EventArgs) Handles Button20.Click
        For i = 0 To ListBox4.Items.Count - 1
            Routine9.Items.Add(ListBox4.Items.Item(i))
        Next
    End Sub
    Private Sub Button22_Click(sender As System.Object, e As System.EventArgs) Handles Button22.Click
        For i = 0 To ListBox4.Items.Count - 1
            Routine10.Items.Add(ListBox4.Items.Item(i))
        Next
    End Sub
    Private Sub Button24_Click(sender As System.Object, e As System.EventArgs) Handles Button24.Click
        For i = 0 To ListBox4.Items.Count - 1
            Routine11.Items.Add(ListBox4.Items.Item(i))
        Next
    End Sub
    Private Sub Button26_Click(sender As System.Object, e As System.EventArgs) Handles Button26.Click
        For i = 0 To ListBox4.Items.Count - 1
            Routine12.Items.Add(ListBox4.Items.Item(i))
        Next
    End Sub

    'Clear Routines
    Private Sub Button39_Click(sender As System.Object, e As System.EventArgs) Handles Button39.Click
        Routine1.Items.Clear()
    End Sub
    Private Sub Button37_Click(sender As System.Object, e As System.EventArgs) Handles Button37.Click
        Routine2.Items.Clear()
    End Sub
    Private Sub Button35_Click(sender As System.Object, e As System.EventArgs) Handles Button35.Click
        Routine3.Items.Clear()
    End Sub
    Private Sub Button33_Click(sender As System.Object, e As System.EventArgs) Handles Button33.Click
        Routine4.Items.Clear()
    End Sub
    Private Sub Button31_Click(sender As System.Object, e As System.EventArgs) Handles Button31.Click
        Routine5.Items.Clear()
    End Sub
    Private Sub Button29_Click(sender As System.Object, e As System.EventArgs) Handles Button29.Click
        Routine6.Items.Clear()
    End Sub
    Private Sub Button38_Click(sender As System.Object, e As System.EventArgs) Handles Button38.Click
        Routine7.Items.Clear()
    End Sub
    Private Sub Button36_Click(sender As System.Object, e As System.EventArgs) Handles Button36.Click
        Routine8.Items.Clear()
    End Sub
    Private Sub Button34_Click(sender As System.Object, e As System.EventArgs) Handles Button34.Click
        Routine9.Items.Clear()
    End Sub
    Private Sub Button32_Click(sender As System.Object, e As System.EventArgs) Handles Button32.Click
        Routine10.Items.Clear()
    End Sub
    Private Sub Button30_Click(sender As System.Object, e As System.EventArgs) Handles Button30.Click
        Routine11.Items.Clear()
    End Sub
    Private Sub Button28_Click(sender As System.Object, e As System.EventArgs) Handles Button28.Click
        Routine12.Items.Clear()
    End Sub

    'Add Routines and Waits
    Private Sub Button40_Click(sender As System.Object, e As System.EventArgs) Handles Button40.Click
        Routines.Items.Add("Routine,1")
    End Sub
    Private Sub Button41_Click(sender As System.Object, e As System.EventArgs) Handles Button41.Click
        Routines.Items.Add("Routine,2")
    End Sub
    Private Sub Button42_Click(sender As System.Object, e As System.EventArgs) Handles Button42.Click
        Routines.Items.Add("Routine,3")
    End Sub
    Private Sub Button43_Click(sender As System.Object, e As System.EventArgs) Handles Button43.Click
        Routines.Items.Add("Routine,4")
    End Sub
    Private Sub Button44_Click(sender As System.Object, e As System.EventArgs) Handles Button44.Click
        Routines.Items.Add("Routine,5")
    End Sub
    Private Sub Button45_Click(sender As System.Object, e As System.EventArgs) Handles Button45.Click
        Routines.Items.Add("Routine,6")
    End Sub
    Private Sub Button52_Click(sender As System.Object, e As System.EventArgs) Handles Button52.Click
        Routines.Items.Add("Routine,7")
    End Sub
    Private Sub Button51_Click(sender As System.Object, e As System.EventArgs) Handles Button51.Click
        Routines.Items.Add("Routine,8")
    End Sub
    Private Sub Button50_Click(sender As System.Object, e As System.EventArgs) Handles Button50.Click
        Routines.Items.Add("Routine,9")
    End Sub
    Private Sub Button49_Click(sender As System.Object, e As System.EventArgs) Handles Button49.Click
        Routines.Items.Add("Routine,10")
    End Sub
    Private Sub Button48_Click(sender As System.Object, e As System.EventArgs) Handles Button48.Click
        Routines.Items.Add("Routine,11")
    End Sub
    Private Sub Button47_Click(sender As System.Object, e As System.EventArgs) Handles Button47.Click
        Routines.Items.Add("Routine,12")
    End Sub
    Private Sub Button53_Click(sender As System.Object, e As System.EventArgs) Handles Button53.Click
        Routines.Items.Add("IdleWait," + NumericUpDown6.Value.ToString)
    End Sub

    'Remove Routine
    Private Sub Button46_Click(sender As System.Object, e As System.EventArgs) Handles Button46.Click
        Try
            Routines.Items.RemoveAt(Routines.SelectedIndex)
        Catch ex As Exception
        End Try
    End Sub

    'Enable Loop of routine playlist
    Private Sub CheckBox2_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles CheckBox2.CheckedChanged
        loop_routines = True
    End Sub

    'Play Routines
    Private Sub Button14_Click(sender As System.Object, e As System.EventArgs) Handles Button14.Click
        If Routines.Items.Count > 0 Then
            If macro_editor_enabled = False Then
                Button14.Text = "Abort"
                macro_editor = True
                macro_editor_enabled = True
                thread = New System.Threading.Thread(AddressOf run_routines)
                thread.Start()
            Else
                macro_editor = False
                macro_editor_enabled = False
                Button14.Text = "Play"
            End If
        Else
            MsgBox("You need to add routines before you can play", MsgBoxStyle.Exclamation, "Aborted")
        End If
    End Sub
    'Run the routines <3 awesome easy
    Public Sub run_routines()
        For i = 0 To Routines.Items.Count - 1
            If Routines.Items.Item(i).ToString = "Routine,1" Then
                For r = 0 To Routine1.Items.Count - 1
                    If Routine1.Items.Item(r).ToString.Split(",").GetValue(0) = "IdleWait" Then
                        System.Threading.Thread.Sleep(Int(Routine1.Items.Item(r).ToString.Split(",").GetValue(1)))
                    Else
                        SerialPort1.WriteLine(Routine1.Items.Item(r))
                        System.Threading.Thread.Sleep(10)
                    End If
                Next
            End If
            If Routines.Items.Item(i).ToString = "Routine,2" Then
                For r = 0 To Routine2.Items.Count - 1
                    If Routine2.Items.Item(r).ToString.Split(",").GetValue(0) = "IdleWait" Then
                        System.Threading.Thread.Sleep(Int(Routine2.Items.Item(r).ToString.Split(",").GetValue(1)))
                    Else
                        SerialPort1.WriteLine(Routine2.Items.Item(r))
                        System.Threading.Thread.Sleep(10)
                    End If
                Next
            End If
            If Routines.Items.Item(i).ToString = "Routine,3" Then
                For r = 0 To Routine3.Items.Count - 1
                    If Routine3.Items.Item(r).ToString.Split(",").GetValue(0) = "IdleWait" Then
                        System.Threading.Thread.Sleep(Int(Routine3.Items.Item(r).ToString.Split(",").GetValue(1)))
                    Else
                        SerialPort1.WriteLine(Routine3.Items.Item(r))
                        System.Threading.Thread.Sleep(10)
                    End If
                Next
            End If
            If Routines.Items.Item(i).ToString = "Routine,4" Then
                For r = 0 To Routine4.Items.Count - 1
                    If Routine4.Items.Item(r).ToString.Split(",").GetValue(0) = "IdleWait" Then
                        System.Threading.Thread.Sleep(Int(Routine4.Items.Item(r).ToString.Split(",").GetValue(1)))
                    Else
                        SerialPort1.WriteLine(Routine4.Items.Item(r))
                        System.Threading.Thread.Sleep(10)
                    End If
                Next
            End If
            If Routines.Items.Item(i).ToString = "Routine,5" Then
                For r = 0 To Routine5.Items.Count - 1
                    If Routine5.Items.Item(r).ToString.Split(",").GetValue(0) = "IdleWait" Then
                        System.Threading.Thread.Sleep(Int(Routine5.Items.Item(r).ToString.Split(",").GetValue(1)))
                    Else
                        SerialPort1.WriteLine(Routine5.Items.Item(r))
                        System.Threading.Thread.Sleep(10)
                    End If
                Next
            End If
            If Routines.Items.Item(i).ToString = "Routine,6" Then
                For r = 0 To Routine6.Items.Count - 1
                    If Routine6.Items.Item(r).ToString.Split(",").GetValue(0) = "IdleWait" Then
                        System.Threading.Thread.Sleep(Int(Routine6.Items.Item(r).ToString.Split(",").GetValue(1)))
                    Else
                        SerialPort1.WriteLine(Routine6.Items.Item(r))
                        System.Threading.Thread.Sleep(10)
                    End If
                Next
            End If
            If Routines.Items.Item(i).ToString = "Routine,7" Then
                For r = 0 To Routine7.Items.Count - 1
                    If Routine7.Items.Item(r).ToString.Split(",").GetValue(0) = "IdleWait" Then
                        System.Threading.Thread.Sleep(Int(Routine7.Items.Item(r).ToString.Split(",").GetValue(1)))
                    Else
                        SerialPort1.WriteLine(Routine7.Items.Item(r))
                        System.Threading.Thread.Sleep(10)
                    End If
                Next
            End If
            If Routines.Items.Item(i).ToString = "Routine,8" Then
                For r = 0 To Routine8.Items.Count - 1
                    If Routine8.Items.Item(r).ToString.Split(",").GetValue(0) = "IdleWait" Then
                        System.Threading.Thread.Sleep(Int(Routine8.Items.Item(r).ToString.Split(",").GetValue(1)))
                    Else
                        SerialPort1.WriteLine(Routine8.Items.Item(r))
                        System.Threading.Thread.Sleep(10)
                    End If
                Next
            End If
            If Routines.Items.Item(i).ToString = "Routine,9" Then
                For r = 0 To Routine9.Items.Count - 1
                    If Routine9.Items.Item(r).ToString.Split(",").GetValue(0) = "IdleWait" Then
                        System.Threading.Thread.Sleep(Int(Routine9.Items.Item(r).ToString.Split(",").GetValue(1)))
                    Else
                        SerialPort1.WriteLine(Routine9.Items.Item(r))
                        System.Threading.Thread.Sleep(10)
                    End If
                Next
            End If
            If Routines.Items.Item(i).ToString = "Routine,10" Then
                For r = 0 To Routine10.Items.Count - 1
                    If Routine10.Items.Item(r).ToString.Split(",").GetValue(0) = "IdleWait" Then
                        System.Threading.Thread.Sleep(Int(Routine10.Items.Item(r).ToString.Split(",").GetValue(1)))
                    Else
                        SerialPort1.WriteLine(Routine10.Items.Item(r))
                        System.Threading.Thread.Sleep(10)
                    End If
                Next
            End If
            If Routines.Items.Item(i).ToString = "Routine,11" Then
                For r = 0 To Routine11.Items.Count - 1
                    If Routine11.Items.Item(r).ToString.Split(",").GetValue(0) = "IdleWait" Then
                        System.Threading.Thread.Sleep(Int(Routine11.Items.Item(r).ToString.Split(",").GetValue(1)))
                    Else
                        SerialPort1.WriteLine(Routine11.Items.Item(r))
                        System.Threading.Thread.Sleep(10)
                    End If
                Next
            End If
            If Routines.Items.Item(i).ToString = "Routine,12" Then
                For r = 0 To Routine12.Items.Count - 1
                    If Routine12.Items.Item(r).ToString.Split(",").GetValue(0) = "IdleWait" Then
                        System.Threading.Thread.Sleep(Int(Routine12.Items.Item(r).ToString.Split(",").GetValue(1)))
                    Else
                        SerialPort1.WriteLine(Routine12.Items.Item(r))
                        System.Threading.Thread.Sleep(10)
                    End If
                Next
            End If
            If Routines.Items.Item(i).ToString.Split(",").GetValue(0) = "IdleWait" Then
                System.Threading.Thread.Sleep(Int(Routines.Items.Item(i).ToString.Split(",").GetValue(1)))
            End If

            If macro_editor_enabled = False Then
                thread.Abort() 'Allows aborting mid-thread
            End If
        Next
        If CheckBox2.CheckState = CheckState.Checked Then
            thread = New System.Threading.Thread(AddressOf run_routines)
            thread.Start()
        Else
            macro_editor = False
            macro_editor_enabled = False
            Button14.Text = "Play"
        End If
    End Sub

    'Mouse Control (Two Checkbox's enable and disable this option)
    Private Sub CheckBox3_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles CheckBox3.CheckedChanged
        If CheckBox3.CheckState = CheckState.Checked Then
            CheckBox1.CheckState = CheckState.Checked
        Else
            CheckBox1.CheckState = CheckState.Unchecked
        End If
    End Sub
    Private Sub CheckBox1_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles CheckBox1.CheckedChanged
        If CheckBox1.CheckState = CheckState.Checked Then
            CheckBox3.CheckState = CheckState.Checked
        Else
            CheckBox3.CheckState = CheckState.Unchecked
        End If
    End Sub

    'Copy Vector
    Private Sub Button59_Click(sender As System.Object, e As System.EventArgs) Handles Button59.Click
        Try
            Clipboard.SetText(ListBox2.SelectedItem)
        Catch ex As Exception
        End Try
    End Sub

    'Paste Vector
    Private Sub Button60_Click(sender As System.Object, e As System.EventArgs) Handles Button60.Click
        If Clipboard.GetText.Split(",").GetValue(1) = "Vector" Then
            If CInt(Clipboard.GetText.Split(",").GetValue(2)) < 1 Or CInt(Clipboard.GetText.Split(",").GetValue(3)) < 1 Then
                MsgBox("Vectors cannot be bellow 1 on the x or y axis", MsgBoxStyle.Exclamation, "Cannot Accept Vector")
                Exit Sub
            End If
            ListBox4.Items.Add(ListBox2.SelectedItem.ToString.Split(",").GetValue(1) + "," + ListBox2.SelectedItem.ToString.Split(",").GetValue(2) + "," + ListBox2.SelectedItem.ToString.Split(",").GetValue(3))
        Else
            MsgBox("Your clipboard does not contain a vector", MsgBoxStyle.Exclamation, "No Vector")
        End If
    End Sub

    'Insert Vector with Name
    Private Sub TextBox2_KeyDown(sender As Object, e As System.Windows.Forms.KeyEventArgs) Handles TextBox2.KeyDown
        If e.KeyCode = Keys.Return Then
            Dim text = TextBox2.Text.Replace(",", "-")
            ListBox2.Items.Add(text + "," + TextBox3.Text)
            TextBox3.Text = "Vector,1,1"
            TextBox2.Text = ""
        End If
    End Sub

    'Remove Selected Vector
    Private Sub Button63_Click(sender As System.Object, e As System.EventArgs) Handles Button63.Click
        Try
            ListBox2.Items.RemoveAt(ListBox2.SelectedIndex)
        Catch ex As Exception
        End Try
    End Sub

    'Clear Vectors
    Private Sub Button64_Click(sender As System.Object, e As System.EventArgs) Handles Button64.Click
        ListBox2.Items.Clear()
    End Sub
End Class